<bugID>873867<Summary>Adjust panelmultiview binding to allow easy swapping of mainviews</Summary><Description>The specification for the bookmarks panel widget (bug 855805) calls for the following behaviour:

1) When the widget is in the main panel, clicking on the widget opens a subview that lists some number of options and bookmarks. Bookmark folders are also visible in this list, but clicking on them opens up that folder in the Library.
2) When the widget is in a toolbar, clicking on the widget opens a panel listing some number of options and bookmarks, but when clicking on a bookmark folder, a subview is opened that displays the contents of that folder. We only go one level deep, so clicking on a folder within the subview opens that folder in a Library.

The panel view that lists the bookmarks and options is common between these two locations, so we'll make use of jaws' patch that opens up subviews within their own panels.

We need, however, to have that panel support subviews, and have it recognize the bookmark panel as the main view. This means making it easy for subviews to become mainviews, and vice versa.

I suggest we drop the notion of panelmainview and panelsubview, and just have panelview tags within a panelmultiview. The mainViewId attribute of the panelmultiview will allow us to set the main view in mark-up, and the setMainView method of the binding will allow us to programmatically swap views in and out of the main view position.

Not entirely sure if this is the best way forward, but it seems to work for the WIP patch I'm putting together for bug 855805. Definitely open to suggestions on this though.</Description></bugID>